package com.minemaarten.signals.client.glasses;

import net.minecraft.client.resources.I18n;
import net.minecraft.entity.Entity;
import net.minecraft.entity.item.EntityMinecart;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import com.minemaarten.signals.network.PacketUpdateMessage;

public class GlassesMessage{
    public final String localizedMessage;
    public final EntityMinecart associatedCart;
    public final BlockPos associatedRouter;

    public GlassesMessage(PacketUpdateMessage packet, World world){
        associatedRouter = packet.pos;
        Entity cart = world.func_73045_a(packet.entityId);
        associatedCart = cart instanceof EntityMinecart ? (EntityMinecart)cart : null;

        String message = packet.message;
        message = I18n.func_135052_a(message);
        message = message.replaceAll("\\$ROUTER\\$", String.format("(%s, %s, %s)", associatedRouter.func_177958_n(), associatedRouter.func_177956_o(), associatedRouter.func_177952_p()));

        if(associatedCart != null) {
            BlockPos cartPos = associatedCart.func_180425_c();
            message = message.replaceAll("\\$CART\\$", String.format("(%s at (%s, %s, %s)", associatedCart.func_70005_c_(), cartPos.func_177958_n(), cartPos.func_177956_o(), cartPos.func_177952_p()));
        } else {
            //Log.warn("Cart is null!");
        }

        //Format the args
        for(int i = 0; i < packet.args.length; i++) {
            if(packet.args[i].startsWith("signals.")) {
                packet.args[i] = I18n.func_135052_a(packet.args[i]);
            }
        }

        localizedMessage = String.format(message, (Object[])packet.args);
    }
}
